<?php
/**
* @version      2.2.3 15.09.2010
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');

class JshoppingControllerManufacturers extends JController{

    function __construct( $config = array() ){
        parent::__construct( $config );

        $this->registerTask( 'add',   'edit' );
        $this->registerTask( 'apply', 'save' );
    }

    function display() {
        $db = &JFactory::getDBO();
        $manufacturer = &$this->getModel("manufacturers");
        $rows = $manufacturer->getAllManufacturers();

        $view=&$this->getView("manufacturer_list", 'html');        
        $view->assign('rows', $rows);        
        $view->display();
    }

    function edit() {
        $db = &JFactory::getDBO();
        $man_id = JRequest::getInt("man_id");
        $manufacturer = &JTable::getInstance('manufacturer', 'jshop');
        $manufacturer->load($man_id);
        $edit = ($man_id)?(1):(0);
        
        $_lang = &$this->getModel("languages");
        $languages = $_lang->getAllLanguages(1);
        $multilang = count($languages)>1;
        
        $nofilter = array();
        JFilterOutput::objectHTMLSafe( $manufacturer, ENT_QUOTES, $nofilter);

        $view=&$this->getView("manufacturer_edit", 'html');        
        $view->assign('manufacturer', $manufacturer);        
        $view->assign('edit', $edit);
        $view->assign('languages', $languages);
        $view->assign('multilang', $multilang);        
        $view->display();
    }

    function save() {
        $jshopConfig = &JSFactory::getConfig();
        
        require_once ($jshopConfig->path.'lib/uploadfile.class.php');        
        
        $apply = JRequest::getVar("apply");
        $db = &JFactory::getDBO();
        $man = &JTable::getInstance('manufacturer', 'jshop');        
        $man_id = JRequest::getInt("manufacturer_id");

        $post = JRequest::get("post");
        $_lang = &$this->getModel("languages");
        $languages = $_lang->getAllLanguages(1);
        foreach($languages as $lang){            
            $post['description_'.$lang->language] = JRequest::getVar('description'.$lang->id,'','post',"string", 2);
        }
        
        if(!$man->bind($post)) {
            JError::raiseWarning("",_JSHOP_ERROR_BIND);
            $this->setRedirect("index.php?option=com_jshopping&controller=manufacturers");
            return 0;
        }
        
        $upload = new UploadFile($_FILES['manufacturer_logo']);
        $upload->setAllowFile(array('jpeg','jpg','gif','png'));
        $upload->setDir($jshopConfig->image_manufs_path);
        if ($upload->upload()){
            if ($man->manufacturer_logo){
                @unlink($jshopConfig->image_manufs_path . "/" . $man->manufacturer_logo);
            }
            $man->manufacturer_logo = $upload->getName();            
        }else{
            if ($upload->getError() != 4){
                JError::raiseWarning("", _JSHOP_ERROR_UPLOADING_IMAGE);
            }
        }
        
        if(!$man->store()) {
            JError::raiseWarning("",_JSHOP_ERROR_SAVE_DATABASE);
            $this->setRedirect("index.php?option=com_jshopping&controller=manufacturers");
            return 0;
        }
        
        if ($this->getTask()=='apply'){
            $this->setRedirect("index.php?option=com_jshopping&controller=manufacturers&task=edit&man_id=".$man->manufacturer_id); 
        }else{
            $this->setRedirect("index.php?option=com_jshopping&controller=manufacturers");
        }
        
    }

    function remove() {
        $cid = JRequest::getVar("cid");
        $db = &JFactory::getDBO();
        $jshopConfig = &JSFactory::getConfig();
        $text = array();
        foreach ($cid as $key => $value) {
            $query = "DELETE FROM `#__jshopping_manufacturers` WHERE `manufacturer_id` = '" . $db->getEscaped($value) . "'";                       
            $manuf = &JTable::getInstance('manufacturer', 'jshop');
            $manuf->load($value);
            $manuf->delete();
            
            $text[]= sprintf(_JSHOP_MANUFACTURER_DELETED, $value);
            if ($manuf->manufacturer_logo){
                @unlink($jshopConfig->image_manufs_path.'/'.$manuf->manufacturer_logo);
            }            
        }
        $this->setRedirect("index.php?option=com_jshopping&controller=manufacturers", implode("</li><li>",$text));
    }
    
    function publish(){
        $this->publishManufacturer(1);
    }
    
    function unpublish(){
        $this->publishManufacturer(0);
    }

    function publishManufacturer($flag) {
        $cid = JRequest::getVar("cid");
        $db = &JFactory::getDBO();
        foreach ($cid as $key => $value) {
            $query = "UPDATE `#__jshopping_manufacturers`
                       SET `manufacturer_publish` = '" . $db->getEscaped($flag) . "'
                       WHERE `manufacturer_id` = '" . $db->getEscaped($value) . "'";
            $db->setQuery($query);
            $db->query();
        }
        $this->setRedirect("index.php?option=com_jshopping&controller=manufacturers");
    }
    
    function delete_foto(){
        $id = JRequest::getInt("id");
        $jshopConfig = &JSFactory::getConfig();
        $manuf = &JTable::getInstance('manufacturer', 'jshop');
        $manuf->load($id);
        @unlink($jshopConfig->image_manufs_path.'/'.$manuf->manufacturer_logo);
        $manuf->manufacturer_logo = "";
        $manuf->store();
        die();
    }
    
    
}
?>		